diff --git a/build-aux/common.mk b/build-aux/common.mk
--- a/build-aux/common.mk
+++ b/build-aux/common.mk
@@ -112,7 +112,7 @@
 XTRA_CFLAGS = @XTRA_CFLAGS@
 WARN_CFLAGS = @WARN_CFLAGS@
 AM_CFLAGS = $(XTRA_CFLAGS)
-ALL_CPPFLAGS = $(CPPFLAGS) $(HDF5_CPPFLAGS) $(Z_CPPFLAGS) $(LLVM_CPPFLAGS)
+ALL_CPPFLAGS = $(CPPFLAGS) $(HDF5_CPPFLAGS) $(Z_CPPFLAGS) $(LIBGCCJIT_CPPFLAGS) $(LLVM_CPPFLAGS)
 
 BUILD_CC = @BUILD_CC@
 BUILD_CFLAGS = @BUILD_CFLAGS@
@@ -254,6 +254,10 @@
 
 LAPACK_LIBS = @LAPACK_LIBS@
 
+LIBGCCJIT_CPPFLAGS = @LIBGCCJIT_CPPFLAGS@
+LIBGCCJIT_LDFLAGS = @LIBGCCJIT_LDFLAGS@
+LIBGCCJIT_LIBS = @LIBGCCJIT_LIBS@
+
 LLVM_CPPFLAGS = @LLVM_CPPFLAGS@
 LLVM_LDFLAGS = @LLVM_LDFLAGS@
 LLVM_LIBS = @LLVM_LIBS@
diff --git a/configure.ac b/configure.ac
--- a/configure.ac
+++ b/configure.ac
@@ -889,6 +889,24 @@
 AC_SUBST(LLVM_LIBS)
 AM_CONDITIONAL([AMCOND_HAVE_LLVM], [test -z "$warn_llvm"])
 
+AC_DEFINE(HAVE_JIT, 1, [Define to 1 if using a JIT (either LLVM or libgccjit).])
+
+# FIXME: add a test for this:
+AC_DEFINE(HAVE_GCCJIT, 1, [Define to 1 if libgccjit is available).])
+
+# FIXME: add CXXFLAGS etc
+# FIXME: hacking it in for now:
+LIBGCCJIT_CPPFLAGS=-I/home/david/coding/gcc-python/gcc-git-jit-blocks/src/gcc/jit/
+LIBGCCJIT_CXXFLAGS=-I/home/david/coding/gcc-python/gcc-git-jit-blocks/src/gcc/jit/
+LIBGCCJIT_LDFLAGS=-L/home/david/coding/gcc-python/gcc-git-jit-blocks/build/gcc
+LIBGCCJIT_LIBS=-lgccjit
+
+AC_SUBST(LIBGCCJIT_CPPFLAGS)
+AC_SUBST(LIBGCCJIT_CXXFLAGS)
+AC_SUBST(LIBGCCJIT_LDFLAGS)
+AC_SUBST(LIBGCCJIT_LIBS)
+
+
 ### Check for HDF5 library.
 
 save_CPPFLAGS="$CPPFLAGS"
@@ -2952,6 +2970,10 @@
   Java CPPFLAGS:               $JAVA_CPPFLAGS
   Java libraries:              $JAVA_LIBS
   LAPACK libraries:            $LAPACK_LIBS
+  libgccjit CPPFLAGS:          $LIBGCCJIT_CPPFLAGS
+  libgccjit CXXFLAGS:          $LIBGCCJIT_CXXFLAGS
+  libgccjit LDFLAGS:           $LIBGCCJIT_LDFLAGS
+  libgccjit libraries:         $LIBGCCJIT_LIBS
   LLVM CPPFLAGS:               $LLVM_CPPFLAGS
   LLVM LDFLAGS:                $LLVM_LDFLAGS
   LLVM libraries:              $LLVM_LIBS
diff --git a/libinterp/Makefile.am b/libinterp/Makefile.am
--- a/libinterp/Makefile.am
+++ b/libinterp/Makefile.am
@@ -32,6 +32,7 @@
   -I$(srcdir)/operators \
   -Iparse-tree -I$(srcdir)/parse-tree \
   -Icorefcn -I$(srcdir)/corefcn \
+  $(LIBGCCJIT_CPPFLAGS) \
   -I$(top_builddir)/libgnu -I$(top_srcdir)/libgnu
 
 AM_CFLAGS += $(WARN_CFLAGS)
diff --git a/libinterp/corefcn/jit-ir.cc b/libinterp/corefcn/jit-ir.cc
--- a/libinterp/corefcn/jit-ir.cc
+++ b/libinterp/corefcn/jit-ir.cc
@@ -30,10 +30,11 @@
 #include <config.h>
 #endif
 
-#ifdef HAVE_LLVM
+#ifdef HAVE_JIT
 
 #include "jit-ir.h"
 
+#if HAVE_LLVM
 #ifdef HAVE_LLVM_IR_FUNCTION_H
 #include <llvm/IR/BasicBlock.h>
 #include <llvm/IR/Instructions.h>
@@ -41,6 +42,7 @@
 #include <llvm/BasicBlock.h>
 #include <llvm/Instructions.h>
 #endif
+#endif
 
 #include "error.h"
 
@@ -208,11 +210,13 @@
   resize_arguments (0);
 }
 
+#if HAVE_LLVM
 llvm::BasicBlock *
 jit_instruction::parent_llvm (void) const
 {
   return mparent->to_llvm ();
 }
+#endif
 
 std::ostream&
 jit_instruction::short_print (std::ostream& os) const
@@ -388,11 +392,13 @@
   return term ? term->successor_count () : 0;
 }
 
+#if HAVE_LLVM
 llvm::BasicBlock *
 jit_block::to_llvm (void) const
 {
   return llvm::cast<llvm::BasicBlock> (llvm_value);
 }
+#endif
 
 std::ostream&
 jit_block::print_dom (std::ostream& os) const
@@ -661,11 +667,13 @@
   return false;
 }
 
+#if HAVE_LLVM
 llvm::PHINode *
 jit_phi::to_llvm (void) const
 {
   return llvm::cast<llvm::PHINode> (jit_value::to_llvm ());
 }
+#endif
 
 // -------------------- jit_terminator --------------------
 size_t
@@ -697,11 +705,13 @@
   return changed;
 }
 
+#if HAVE_LLVM
 llvm::TerminatorInst *
 jit_terminator::to_llvm (void) const
 {
   return llvm::cast<llvm::TerminatorInst> (jit_value::to_llvm ());
 }
+#endif
 
 // -------------------- jit_call --------------------
 bool
@@ -842,4 +852,4 @@
   return jit_typeinfo::end (ctx.value, ctx.index, ctx.count);
 }
 
-#endif
+#endif /* ifdef HAVE_JIT */
diff --git a/libinterp/corefcn/jit-ir.h b/libinterp/corefcn/jit-ir.h
--- a/libinterp/corefcn/jit-ir.h
+++ b/libinterp/corefcn/jit-ir.h
@@ -25,12 +25,16 @@
 #if !defined (octave_jit_ir_h)
 #define octave_jit_ir_h 1
 
-#ifdef HAVE_LLVM
+#ifdef HAVE_JIT
 
 #include <list>
 #include <stack>
 #include <set>
 
+#ifdef HAVE_GCCJIT
+#include "libgccjit++.h"
+#endif
+
 #include "jit-typeinfo.h"
 
 // The low level octave jit ir
@@ -188,7 +192,9 @@
 jit_value : public jit_internal_list<jit_value, jit_use>
 {
 public:
-  jit_value (void) : llvm_value (0), ty (0), mlast_use (0),
+  jit_value (void) : llvm_value (0),
+                     m_gcc_lvalue (), m_gcc_rvalue (),
+                     ty (0), mlast_use (0),
                      min_worklist (false) {}
 
   virtual ~jit_value (void);
@@ -212,10 +218,19 @@
 
   jit_type *type (void) const { return ty; }
 
+#if HAVE_LLVM
   llvm::Type *type_llvm (void) const
   {
     return ty ? ty->to_llvm () : 0;
   }
+#endif
+
+#if HAVE_GCCJIT
+  gccjit::type type_gccjit (void) const
+  {
+    return ty ? ty->to_gccjit () : gccjit::type ();
+  }
+#endif
 
   const std::string& type_name (void) const
   {
@@ -247,6 +262,7 @@
 
   virtual void accept (jit_ir_walker& walker) = 0;
 
+#if HAVE_LLVM
   bool has_llvm (void) const
   {
     return llvm_value;
@@ -262,6 +278,34 @@
   {
     llvm_value = compiled;
   }
+#endif
+
+#if 1
+  bool has_lvalue (void) const
+  {
+    return m_gcc_lvalue.get_inner_lvalue ();
+  }
+  bool has_rvalue (void) const
+  {
+    return m_gcc_rvalue.get_inner_rvalue ();
+  }
+  gccjit::lvalue as_lvalue (void) const
+  {
+    return m_gcc_lvalue;
+  }
+  gccjit::rvalue as_rvalue (void) const
+  {
+    return m_gcc_rvalue;
+  }
+  void stash_lvalue (gccjit::lvalue lvalue)
+  {
+    m_gcc_lvalue = lvalue;
+  }
+  void stash_rvalue (gccjit::rvalue rvalue)
+  {
+    m_gcc_rvalue = rvalue;
+  }
+#endif
 
 protected:
   std::ostream& print_indent (std::ostream& os, size_t indent = 0) const
@@ -271,7 +315,13 @@
     return os;
   }
 
+#if HAVE_LLVM
   llvm::Value *llvm_value;
+#endif
+#if HAVE_GCCJIT
+  gccjit::lvalue m_gcc_lvalue;
+  gccjit::rvalue m_gcc_rvalue;
+#endif
 private:
   jit_type *ty;
   jit_instruction *mlast_use;
@@ -371,22 +421,26 @@
     return marguments[i].value ();
   }
 
+#if HAVE_LLVM
   llvm::Value *argument_llvm (size_t i) const
   {
     assert (argument (i));
     return argument (i)->to_llvm ();
   }
+#endif
 
   jit_type *argument_type (size_t i) const
   {
     return argument (i)->type ();
   }
 
+#if HAVE_LLVM
   llvm::Type *argument_type_llvm (size_t i) const
   {
     assert (argument (i));
     return argument_type (i)->to_llvm ();
   }
+#endif
 
   std::ostream& print_argument (std::ostream& os, size_t i) const
   {
@@ -452,7 +506,9 @@
     return mlocation;
   }
 
+#if HAVE_LLVM
   llvm::BasicBlock *parent_llvm (void) const;
+#endif
 
   void stash_parent (jit_block *aparent,
                      std::list<jit_instruction *>::iterator alocation)
@@ -494,10 +550,10 @@
 jit_argument : public jit_value
 {
 public:
-  jit_argument (jit_type *atype, llvm::Value *avalue)
+  jit_argument (jit_type *atype/*, llvm::Value *avalue*/)
   {
     stash_type (atype);
-    stash_llvm (avalue);
+    //stash_llvm (avalue);
   }
 
   virtual std::ostream& print (std::ostream& os, size_t indent = 0) const
@@ -584,6 +640,13 @@
 
   const std::string& name (void) const { return mname; }
 
+  std::string name_and_id (void) const
+  {
+    std::ostringstream os;
+    short_print (os);
+    return os.str ();
+  }
+
   jit_instruction *prepend (jit_instruction *instr);
 
   jit_instruction *prepend_after_phi (jit_instruction *instr);
@@ -719,7 +782,9 @@
     return os;
   }
 
+#if HAVE_LLVM
   llvm::BasicBlock *to_llvm (void) const;
+#endif
 
   std::list<jit_block *>::iterator location (void) const
   { return mlocation; }
@@ -975,10 +1040,12 @@
     return mincomming[i].value ();
   }
 
+#if HAVE_LLVM
   llvm::BasicBlock *incomming_llvm (size_t i) const
   {
     return incomming (i)->to_llvm ();
   }
+#endif
 
   virtual void construct_ssa (void) { }
 
@@ -1009,7 +1076,9 @@
     return os;
   }
 
+#if HAVE_LLVM
   llvm::PHINode *to_llvm (void) const;
+#endif
 
   JIT_VALUE_ACCEPT;
 private:
@@ -1037,10 +1106,12 @@
     return static_cast<jit_block *> (argument (idx));
   }
 
+#if HAVE_LLVM
   llvm::BasicBlock *successor_llvm (size_t idx = 0) const
   {
     return successor (idx)->to_llvm ();
   }
+#endif
 
   size_t successor_index (const jit_block *asuccessor) const;
 
@@ -1068,7 +1139,9 @@
 
   virtual bool infer (void);
 
+#if HAVE_LLVM
   llvm::TerminatorInst *to_llvm (void) const;
+#endif
 protected:
   virtual bool check_alive (size_t) const { return true; }
 private:
@@ -1106,10 +1179,12 @@
     return cond ()->short_print (os);
   }
 
+#if HAVE_LLVM
   llvm::Value *cond_llvm (void) const
   {
     return cond ()->to_llvm ();
   }
+#endif
 
   virtual size_t successor_count (void) const { return 2; }
 
@@ -1351,10 +1426,12 @@
     return result ()->type ();
   }
 
+#if HAVE_LLVM
   llvm::Value *result_llvm (void) const
   {
     return result ()->to_llvm ();
   }
+#endif
 
   virtual std::ostream& print (std::ostream& os, size_t indent = 0) const
   {
@@ -1431,5 +1508,5 @@
 
 #undef JIT_VALUE_ACCEPT
 
+#endif /* ifdef HAVE_JIT */
 #endif
-#endif
